/*
	RC4 Documents - Hash functions for old Word, Excel, PDF documents.
	Copyright (C) 2013 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "excel97.h"
#include "md5.h"
#include "rc4.h"

void excel97(const void *inKey, void *hash)
{
	uint8_t keyTab[256] = {RC4_0x00_TO_0xFF};
	uint32_t key[4], j = 0, tmp;
	uint8_t tmp8, tmp8_2;

	md5_72(inKey, key);
	for (uint32_t i = 0; i < 256; i++)
	{
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x00]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x01]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x02]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x03]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x04]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x05]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x06]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x07]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x08]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x09]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x0a]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x0b]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x0c]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x0d]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x0e]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0x0f]);
	}
	j = 0;
	// WriteAccess_Offset + 3 + 54 = 0x9b
	RC4_SKIP(1, j, keyTab, tmp);
	RC4_SKIP(2, j, keyTab, tmp);
	RC4_SKIP(3, j, keyTab, tmp);
	for (uint32_t i = 4; i <= 0x9b; i++)
	{
		RC4_SKIP(i, j, keyTab, tmp); i++;
		RC4_SKIP(i, j, keyTab, tmp); i++;
		RC4_SKIP(i, j, keyTab, tmp); i++;
		RC4_SKIP(i, j, keyTab, tmp);
	}
	RC4_GET_BYTE     (0x9c, j, keyTab, tmp, ((uint8_t*) key)[ 0]);
	RC4_GET_BYTE     (0x9d, j, keyTab, tmp, ((uint8_t*) key)[ 1]);
	RC4_GET_BYTE     (0x9e, j, keyTab, tmp, ((uint8_t*) key)[ 2]);
	RC4_GET_BYTE     (0x9f, j, keyTab, tmp, ((uint8_t*) key)[ 3]);
	RC4_GET_BYTE     (0xa0, j, keyTab, tmp, ((uint8_t*) key)[ 4]);
	RC4_GET_BYTE     (0xa1, j, keyTab, tmp, ((uint8_t*) key)[ 5]);
	RC4_GET_BYTE     (0xa2, j, keyTab, tmp, ((uint8_t*) key)[ 6]);
	RC4_GET_BYTE     (0xa3, j, keyTab, tmp, ((uint8_t*) key)[ 7]);
	RC4_GET_BYTE     (0xa4, j, keyTab, tmp, tmp8);
	RC4_SKIP         (0xa5, j, keyTab, tmp);
	RC4_GET_BYTE_LAST(0xa6, j, keyTab,      tmp8_2);
	((uint32_t*) hash)[0] = key[0] ^ key[1];
	((uint8_t*)  hash)[4] = tmp8 ^ tmp8_2;
}
