/*
	RC4 Documents - Hash functions for old Word, Excel, PDF documents.
	Copyright (C) 2013 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "pdf40.h"
#include "rc4.h"

void pdf40(const void *inKey, void *hash)
{
	uint8_t keyTab[256] = {RC4_0x00_TO_0xFF};
	uint32_t key[2], j = 0, tmp;

	key[0] = ((uint32_t*) inKey)[0];
	key[1] = ((uint32_t*) inKey)[1];
	RC4_KEY(0, j, keyTab, tmp, ((uint8_t*) key)[0]);
	for (uint32_t i = 1; i < 256; i++)
	{
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[1]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[2]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[3]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[4]); i++;
		RC4_KEY(i, j, keyTab, tmp, ((uint8_t*) key)[0]);
	}
	j = 0;
	RC4_SKIP         (0x01, j, keyTab, tmp); // Skip the first one because it is not evenly distributed
	RC4_GET_BYTE     (0x02, j, keyTab, tmp, ((uint8_t*) hash)[0]);
	RC4_GET_BYTE     (0x03, j, keyTab, tmp, ((uint8_t*) hash)[1]);
	RC4_GET_BYTE     (0x04, j, keyTab, tmp, ((uint8_t*) hash)[2]);
	RC4_GET_BYTE     (0x05, j, keyTab, tmp, ((uint8_t*) hash)[3]);
	RC4_GET_BYTE_LAST(0x06, j, keyTab,      ((uint8_t*) hash)[4]);
}
